=== debian/changelog ===
migraphx (7.1.1-4) unstable; urgency=medium

  [ Dylan Aïssi ]
  * Make lintian-overrides non-architecture specific
  * Apply c++filt on libmigraphx-c3.symbols
  * Add architecture-endianness to the symbols file
  * Don't use c++filt on some symbols
  * libmigraphx-c3.symbols: add ppc64el symbols
  * Mark migraphx-doc as 'Multi-Arch: foreign'
  * Mark migraphx-tools as 'Multi-Arch: same'

 -- Utkarsh Raj <encode.sh@protonmail.com>  Sat, 28 Feb 2026 22:21:48 +0530

migraphx (7.1.1-3) unstable; urgency=medium

  * Fix tests (Closes: #1128949). Thanks Adrian Bunk!
  * Limit to 64 bit architectures.

 -- Utkarsh Raj <encode.sh@protonmail.com>  Wed, 25 Feb 2026 21:55:43 +0530

migraphx (7.1.1-2) unstable; urgency=medium

  * Fix FTBFS on Architecture: all

 -- Utkarsh Raj <encode.sh@protonmail.com>  Tue, 24 Feb 2026 14:42:22 +0530

migraphx (7.1.1-1) unstable; urgency=medium

  [ Utkarsh Raj ]
  * New upstream version 7.1.1
  * Update symbols file
  * Drop fix-msgpack.patch
  * Update standards-version
  * Remove redundant fields in d/control
  * Update copyright
  * Add lintian overrides
  * Fix libmigraphx_py.so target path.
  * Add condition to process doc

  [ Dylan Aïssi ]
  * Add debian/salsa-ci.yml
  * salsa-ci: disable i386 because unsupported

 -- Dylan Aïssi <daissi@debian.org>  Mon, 23 Feb 2026 14:19:56 +0100
