=== debian/control ===
Source: migraphx
Section: graphics
Maintainer: Debian ROCm Team <debian-ai@lists.debian.org>
Uploaders:
 Utkarsh Raj <encode.sh@protonmail.com>
Build-Depends:
 architecture-is-64-bit,
 clang,
 cmake,
 debhelper-compat (= 13),
 libboost-dev,
 libhalf-dev,
 libmsgpack-c-dev,
 libmsgpack-cxx-dev,
 libprotobuf-dev,
 libsqlite3-dev,
 nlohmann-json3-dev,
 protobuf-compiler,
 pybind11-dev,
 rocm-cmake,
Build-Depends-Indep:
 python3-rocm-docs (>= 1.20.0-1~) <!nodoc>,
 sphinx-common <!nodoc>,
Standards-Version: 4.7.3
Vcs-Git: https://salsa.debian.org/rocm-team/migraphx.git
Vcs-Browser: https://salsa.debian.org/rocm-team/migraphx
Homepage: https://github.com/ROCm/AMDMIGraphX/

Package: migraphx
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: AMD MIGraphX - driver
 AMDMIGraphX is a graph inference engine and compiler that accelerates
 machine-learning models by leveraging several graph-level transformations
 and optimizations.
 .
 This package ships the AMD MIGraphX driver.

Package: migraphx-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Build-Profiles: <!nodoc>
Depends:
 ${misc:Depends},
 ${sphinxdoc:Depends},
Description: AMD MIGraphX - doc
 AMDMIGraphX is a graph inference engine and compiler that accelerates
 machine-learning models by leveraging several graph-level transformations
 and optimizations.
 .
 This package provides the AMD MIGraphX documentation.

Package: migraphx-tools
Section: libs
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: AMD MIGraphX - extension libraries
 AMDMIGraphX is a graph inference engine and compiler that accelerates
 machine-learning models by leveraging several graph-level transformations
 and optimizations.
 .
 This package contains the shared runtime extension libraries.

Package: migraphx-tests
Section: libdevel
Architecture: any
Depends:
 migraphx-tools (= ${binary:Version}),
 libmigraphx-c3 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: AMD MIGraphX - test binaries
 AMDMIGraphX is a graph inference engine and compiler that accelerates
 machine-learning models by leveraging several graph-level transformations
 and optimizations.
 .
 This package contains test binaries.

Package: migraphx-dev
Section: libdevel
Architecture: any
Depends:
 migraphx-tools (= ${binary:Version}),
 ${misc:Depends},
Description: AMD MIGraphX - extension development files
 AMDMIGraphX is a graph inference engine and compiler that accelerates
 machine-learning models by leveraging several graph-level transformations
 and optimizations.
 .
 This package contains extension development files.

Package: libmigraphx-c3
Section: libs
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: AMD MIGraphX C API - library
 AMDMIGraphX is a graph inference engine and compiler that accelerates
 machine-learning models by leveraging several graph-level transformations
 and optimizations.
 .
 This package contains the shared C runtime library.

Package: libmigraphx-c-dev
Section: libdevel
Architecture: any
Depends:
 libmigraphx-c3 (= ${binary:Version}),
 ${misc:Depends},
Description: AMD MIGraphX C API - development files
 AMDMIGraphX is a graph inference engine and compiler that accelerates
 machine-learning models by leveraging several graph-level transformations
 and optimizations.
 .
 This package contains development files.
