=== debian/tests/control ===
Test-Command: debian/tests/run-tests
Features: test-name=migraphx-cpu-tests
Depends: migraphx-tests, g++
Restrictions: allow-stderr
Architecture: any
